LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.ALL;
USE ieee.std_logic_unsigned.ALL;

ENTITY ImEditE IS
	port(	PixR: in std_logic_vector(11 downto 0);	
			Mode: in std_logic_vector(3 downto 0);
			WeA: out std_logic_vector(0 downto 0);
			PixE: out std_logic_vector(11 downto 0)
			);
END ImEditE;

ARCHITECTURE ImEditA OF ImEditE IS
	signal Add: std_logic_vector(5 downto 0);
	signal Conv: integer;
BEGIN
	process (Mode, PixR, Add, Conv) is
	begin
		Case Mode is 
			When "0000" =>
				PixE<=PixR;
				WeA<="0";
			When "0001" =>
				PixE<=PixR;
				WeA<="1";
			When "0010" =>
				PixE<=PixR and "111100000000";
				WeA<="1";
			When "0011" =>
				PixE<=PixR and "000011110000";
				WeA<="1";
			When "0100" =>
				PixE<=PixR and "000000001111";
				WeA<="1";
			When "0101" =>
				Conv <= conv_integer(PixR(11 downto 8))+
							conv_integer(PixR(7 downto 4))+
							conv_integer(PixR(3 downto 0));
				Add <= conv_std_logic_vector (Conv, 6);						
				PixE<=Add(5 downto 2) & Add(5 downto 2) & Add(5 downto 2);
				WeA<="1";
			When "0110" =>
				Conv <= conv_integer(PixR(11 downto 8))+
							conv_integer(PixR(7 downto 4))+
							conv_integer(PixR(3 downto 0));
				if Conv > 22 then
					PixE <= (others => '1');
				else 
					PixE<= (others => '0');
				end if;
				WeA<="1";
			When "0111" =>
				PixE <= "011001100110";
				WeA <= "1";
			When "1000" =>
				PixE <= "010001000100";
				WeA <= "1";	
			When "1001" =>
				PixE <= "001000100010";
				WeA <= "1";	
			When "1010" =>
				PixE <= (others => '0');
				WeA <= "1";	
			When "1011" =>
				PixE <= "111100000000";
				WeA <= "1";	
			When "1100" =>
				PixE <= "000011110000";
				WeA <= "1";	
			When "1101" =>
				PixE <= "000000001111";
				WeA <= "1";	
			When "1110" =>
				PixE <= "111100001111";
				WeA <= "1";
			When "1111" =>
				PixE <= "111111110000";
				WeA <= "1";	
			When Others =>
				PixE<=PixR;
				WeA<="1";
		End Case;
	end process;

END ImEditA;

-- pragma synthesis_off 
